#include <IRremote.h>

// RC5 codes
int powerON = 0xC;
int powerOFF = 0x80C;
int mute = 0xD;
int unMute = 0x80D;
int channelUP1 = 0x1C;
int channelUP2 = 0x81C;
int channelDOWN1 = 0x1D;
int channelDOWN2 = 0x81D;
int volUP1 = 0x2B;
int volUP2 = 0x82B;
int volDOWN1 = 0x2C;
int volDOWN2 = 0x82C;

//Pin assignments
//IRLED needs to be in pin fucking 3. 
//skip 9 i broke a wire off in it 

const int volUpPin =  10;
const int volDownPin = 8;
const int powerButtonPin = 7;
const int muteButtonPin = 6 ;
const int chanUpPin = 5 ;
const int chanDownPin = 4 ;
const int ledPin = 13;

//variables that will change

int volUpState = 0;
int volUpCode = volUP1;

int volDownState = 0;
int volDownCode = volDOWN1;

int powerButtonState = 0;
int powerCode = powerON;

int muteButtonState = 0;
int muteCode= mute;

int chanUpState = 0;
int chanUpCode = channelUP1;

int chanDownState = 0;
int chanDownCode = channelDOWN1;



//IR variable
IRsend irsend;



void setup() {
  
  // input buttons
  pinMode(volUpPin, INPUT);
  pinMode(volDownPin, INPUT);
  pinMode(powerButtonPin, INPUT);
  pinMode(muteButtonPin, INPUT);
  pinMode(chanUpPin, INPUT);
  pinMode(chanDownPin, INPUT);

  //output built in led 
  pinMode(ledPin, OUTPUT);
  

}

void loop() {
  // read the state of the pushbutton value:
  volUpState = digitalRead(volUpPin);
  volDownState = digitalRead(volDownPin);
  powerButtonState = digitalRead(powerButtonPin);
  muteButtonState = digitalRead(muteButtonPin);
  chanUpState = digitalRead(chanUpPin);
  chanDownState = digitalRead(chanDownPin);

  if (volUpState == HIGH){
    //SEND VOL UP CODE
    switch (volUpCode){
      case 0x2B:
      irsend.sendRC5(volUP1, 12);
      volUpCode = volUP2;
      break;

      case 0x82B:
      irsend.sendRC5(volUP2, 12);
      volUpCode = volUP1;
      break;
    }
  }
  
  else if (volDownState == HIGH){
    //SEND VOL DOWN CODE
    switch (volDownCode){
      case 0x2C:
      irsend.sendRC5(volDOWN1, 12);
      volDownCode = volDOWN2;
      break;

      case 0x82C:
      irsend.sendRC5(volDOWN2, 12);
      volDownCode = volDOWN1;
      break;
    }
  }
  
  else if (powerButtonState == HIGH){

    switch(powerCode){
      case 0xC:
      irsend.sendRC5(powerON, 12);
      powerCode = powerOFF;
      break;

      case 0x80C:
      irsend.sendRC5(powerOFF, 12);
      powerCode = powerON;
      break;
    }
  }
  else if (muteButtonState == HIGH){
    //SEND MUTE BUTTON CODE
    switch(muteCode){
      case 0xD:
      irsend.sendRC5(mute, 12);
      muteCode = unMute;
      break;

      case 0x80D:
      irsend.sendRC5(unMute, 12);
      muteCode = mute;
      break;
    }
  }
  else if (chanUpState == HIGH){
    //SEND CHAN UP CODE

    switch(chanUpCode){
    
       case 0x1C:
       irsend.sendRC5(channelUP1, 12);
       chanUpCode = channelUP2;
       break;

       case 0x81C:
       irsend.sendRC5(channelUP2, 12);
       chanUpCode = channelUP1;
       break;
    }
  }
  else if (chanDownState == HIGH){
    //SEND CHAN DOWN CODE

    switch (chanDownCode){
      case 0x1D:
      irsend.sendRC5(channelDOWN1, 12);
      chanDownState = channelDOWN2;
      break;

      case 0x81D:
      irsend.sendRC5(channelDOWN2, 12);
      chanDownState = channelDOWN1;
      break;
    }
  
  }
  
    
  

}


 


